/*
Copyright (C) 1999/2000 Hendrik Lipka.
All rights reserved.

This program is free software; you can redistribute it and/or modify it under the terms
of the GNU General Public License as published by the Free Software Foundation;
either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along with this
program; if not, write to the Free Software Foundation, Inc., 675 Mass Ave,
Cambridge, MA 02139, USA or see http://www.gnu.org

If you encounter problems or have a suggestion, please mail to:
hli@hendriklipka.de
*/
package de.hendriklipka.pdfconv.image;

import de.hendriklipka.pdfconv.config.ImageConfig;
import net.sourceforge.jiu.codecs.BMPCodec;
import net.sourceforge.jiu.codecs.CodecMode;
import net.sourceforge.jiu.color.reduction.RGBToGrayConversion;
import net.sourceforge.jiu.color.reduction.ReduceToBilevelThreshold;
import net.sourceforge.jiu.color.reduction.ReduceShadesOfGray;
import net.sourceforge.jiu.data.PixelImage;
import net.sourceforge.jiu.gui.awt.BufferedRGB24Image;

import java.awt.image.BufferedImage;

public class BMPImageWriter extends ImageWriter
{
    public BMPImageWriter()
    {
        super();
    }

    public boolean saveImage(String current_image, BufferedImage image, ImageConfig config)
    {
        try
        {
            BufferedRGB24Image img=new BufferedRGB24Image(image);
            RGBToGrayConversion conv=new RGBToGrayConversion();
            conv.setInputImage(img);
            conv.process();
            PixelImage img2=conv.getOutputImage();
            ReduceShadesOfGray conv2=new ReduceShadesOfGray(2);
            conv2.setInputImage(img2);
            conv2.process();
            PixelImage img3=conv2.getOutputImage();
            BMPCodec codec=new BMPCodec();
            codec.setImage(img3);
            codec.setFile(current_image+".bmp", CodecMode.SAVE);
            codec.process();
            codec.close();
            return true;
        }
        catch (Exception e)
        {
            e.printStackTrace();
        }
        return false;
    }
}

/*
    public boolean saveImage(String current_image, BufferedImage image, ImageConfig config)
    {
        try
        {
            BMPImageSaver is;
            is=new BMPImageSaver();
            is.setSaveImage(image);
            is.setSavePath(current_image+".bmp");
            is.saveIt();

            // Wait until saving is ready.
            while ((is.checkSave()&(ImageObserver.ALLBITS|ImageObserver.ABORT|ImageObserver.ERROR))==0)
            {
                try
                {
                    Thread.sleep(100);
                }
                catch (InterruptedException e)
                {
                    System.exit(1);
                }
            }

            return true;
        }
        catch (Exception e)
        {
            e.printStackTrace();
        }
        return false;
    }

*/